(in-package "CL-USER")

;;; This uses CCL:FASL-CONCATENATE to produce a single FASL file;
;;; loading that file is equivalent to loading all of the specified
;;; CLX fasl files in sequence.  The single file might load more
;;; quickly and might be more convenient to distribute; if it's saved
;;; to a directory that REQUIRE looks in, REQUIRE can be used to load
;;; it.

(defun concat-clx (target-dir source-dir)
  "TARGET-DIR should typically be something like \"ccl:library;\"
   (e.g., a directory pathname on OpenMCL's *module-search-path*.
   SOURCE-DIR should be a directory containing CLX FASL files.  A typical
   call might be something like:
   ? (concat-clx \"ccl:library;\" \"/usr/local/src/clx/\")"
  (ccl:fasl-concatenate 
   (compile-file-pathname (merge-pathnames target-dir "clx"))
   (mapcar #'(lambda (p)
               (compile-file-pathname
                (make-pathname :name p
                               :defaults source-dir)))
           '("package"
             "depdefs"
             "clx"
             "dependent"
	     "macros"
	     "bufmac"
             "buffer"
             "display"
             "gcontext"
             "input"
             "requests"
             "fonts"
             "graphics"
             "text"
             "attributes"
             "translate"
             "keysyms"
             "manager"
             "image"
             "resource"
             "shape"
             "xvidmode"))
   :if-exists :supersede))
